> This page is for Developer Documentation.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.benchling.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.benchling.com/_mcp/server.

# Update AppDefinition

PATCH https://{tenant_name}.benchling.com/api/v3/app-definition/{app_definition_id}
Content-Type: application/json

Update AppDefinition.

Reference: https://docs.benchling.com/docs/api/benchling-api/appdefinition/update

## Authentication

- `Authorization` header (bearer token, required) — Bearer authentication of the form `Bearer <token>`, where token is your auth token.

## Request

### Path parameters

- `app_definition_id` (string, required) — ID of the AppDefinition.

### Headers

- `EARLY-ACCESS` (string, optional) — Set to true to access beta operations via /api/v3.

### Body (application/json)

This endpoint expects an object.

- `configurationPublicKey` (string, optional, nullable)
- `webhookHeaders` (list of map from string to any, optional)
- `webhookUrl` (string, optional, nullable)
- `webhookUrlRouting` (enum, optional)
  - Allowed values: `SUFFIXED`, `STABLE`

## Response

### 200

OK

- `__typename` (string, optional)
- `clientId` (string, optional)
- `configurationPublicKey` (string, optional, nullable)
- `createdAt` (string, optional)
- `id` (string, optional)
- `latestReleaseVersion` (AppDefinitionVersionRef, optional, nullable)
- `modifiedAt` (string, optional)
- `owner` (PrincipalRef, optional, nullable)
- `owningTenant` (string, optional, nullable)
- `versions` (string, optional) — All versions of this App Definition.
- `webhookUrl` (string, optional, nullable)
- `webhookUrlRouting` (enum, optional, nullable)
  - Allowed values: `SUFFIXED`, `STABLE`

## Errors

### 400 App Definition Update Request Bad Request Error

Bad Request

- `detail` (GeneralErrorDetail, required, nullable)
- `instance` (string, required)
- `status` (integer, required)
- `title` (string, required, nullable)
- `type` (string, required)
- `invalidId` (string, optional)

### 403 App Definition Update Request Forbidden Error

Forbidden

- `detail` (GeneralErrorDetail, required, nullable)
- `instance` (string, required)
- `status` (integer, required)
- `title` (string, required, nullable)
- `type` (string, required)
- `invalidId` (string, optional)

### 404 App Definition Update Request Not Found Error

Not Found

- `detail` (GeneralErrorDetail, required, nullable)
- `instance` (string, required)
- `status` (integer, required)
- `title` (string, required, nullable)
- `type` (string, required)
- `invalidId` (string, optional)

### 409 App Definition Update Request Conflict Error

Conflict

- `detail` (GeneralErrorDetail, required, nullable)
- `instance` (string, required)
- `status` (integer, required)
- `title` (string, required, nullable)
- `type` (string, required)
- `invalidId` (string, optional)

### 429 App Definition Update Request Too Many Requests Error

Too Many Requests

- `detail` (TooManyRequestsErrorBodyDetail, required, nullable)
- `instance` (string, required)
- `status` (integer, required)
- `title` (string, required, nullable)
- `type` (string, required)
- `invalidId` (string, optional)
- `violated-policies` (list of enum, optional) — The budget policies that rejected the request, in canonical order: `user`, `integration`, then `tenant`.
  - Allowed values: `user`, `integration`, `tenant`

### 500 App Definition Update Request Internal Server Error

Internal Server Error

- `detail` (InternalServerErrorBodyDetail, required, nullable)
- `instance` (string, required)
- `status` (integer, required)
- `title` (string, required, nullable)
- `type` (string, required)
- `errorId` (string, optional)

## Types

### AppDefinitionVersionRef

- `__typename` (string, optional)
- `id` (string, optional)

### PrincipalRef

- `__typename` (string, optional)
- `id` (string, optional)

### GeneralErrorDetail

### TooManyRequestsErrorBodyDetail

### InternalServerErrorBodyDetail

## Examples

**Request**

```json
{}
```

**Response**

```json
{
  "__typename": "__typename",
  "clientId": "clientId",
  "configurationPublicKey": "configurationPublicKey",
  "createdAt": "createdAt",
  "id": "id",
  "latestReleaseVersion": {
    "__typename": "__typename",
    "id": "id"
  },
  "modifiedAt": "modifiedAt",
  "owner": {
    "__typename": "__typename",
    "id": "id"
  },
  "owningTenant": "owningTenant",
  "versions": "versions",
  "webhookUrl": "webhookUrl",
  "webhookUrlRouting": "SUFFIXED"
}
```

**SDK Code**

```python
import requests

url = "https://{tenant_name}.benchling.com/api/v3/app-definition/app_definition_id"

payload = {}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.patch(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://{tenant_name}.benchling.com/api/v3/app-definition/app_definition_id';
const options = {
  method: 'PATCH',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```